<?php
/**
 * @package    Checkout Shipping Delivery plugin for Joomla! HikaShop
 * @version    1.0.0
 * @author     Obsidev S.A.R.L.
 * @copyright  (C) 2011-2022 OBSIDEV. All rights reserved.
 * @license    GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');
?><?php
class plgHikashopCheckout_shipping_delivery extends JPlugin {
	public function onCheckoutStepList(&$list) {
		$list['plg.delivery.shipping'] = array(
			'name' => JText::_('HIKASHOP_SHIPPING_DELIVERY'),
			'params' => array()
		);
	}

	public function onHikashopPluginController($ctrl) {
		if($ctrl != 'checkout_shipping_delivery')
			return;

		$app = JFactory::getApplication();
		$isAdmin = version_compare(JVERSION,'4.0','<') ? $app->isAdmin() : $app->isClient('administrator');
		if(!$isAdmin)
			return;

		$this->loadLanguage('plg_hikashop_checkout_shipping_delivery', JPATH_ADMINISTRATOR);
		return array(
			'type' => 'hikashop',
			'name' => 'checkout_shipping_delivery',
			'prefix' => 'ctrl'
		);
	}

	public function onViewsListingFilter(&$views, $client) {
		switch($client){
			case 1:
				break;
			case 0:
			default:
				$views[] = array(
					'client_id' => 0,
					'name' => 'Checkout Shipping Delivery',
					'component' => 'plg_hikashop_checkout_shipping_delivery',
					'view' => dirname(__FILE__).DS.'views'.DS
				);
				break;
		}
	}

	public function onCheckoutStepDisplay($layoutName, &$html, &$view, $pos = null, $options = null) {
		if($layoutName != 'plg.delivery.shipping')
			return;
		$params = new stdClass();
		$params->view = $view;
		$params->pos = $pos;
		$params->options = $options;
		$html .= $this->displayView('shipping_delivery', $params);
	}

	public function onBeforeCheckoutStep($controllerName, &$go_back, $original_go_back, &$controller) {
	}

	public function onAfterCheckoutStep($controllerName, &$go_back, $original_go_back, &$controller) {
	}

	private function displayView($layout, $params = array()) {
		$app = JFactory::getApplication();
		$doc = JFactory::getDocument();

		$base_path = rtrim(dirname(__FILE__),DS);

		$controller = new hikashopBridgeController(array(
			'name' => 'checkout_shipping_delivery',
			'base_path' => $base_path
		));

		$viewType = $doc->getType();
		if(empty($viewType))
			$viewType = 'html';

		$view = $controller->getView( '', $viewType, '', array('base_path' => $base_path));

		$folder	= $base_path.DS.'views'.DS.$view->getName().DS.'tmpl';
		$view->addTemplatePath($folder);

		$folder	= JPATH_BASE.DS.'templates'.DS.$app->getTemplate().DS.'html'.DS.HIKASHOP_COMPONENT.DS.$view->getName();
		$view->addTemplatePath($folder);

		$old = $view->setLayout($layout);

		ob_start();
		$view->display(null,$params);

		$js = @$view->js;
		if(!empty($old))
			$view->setLayout($old);
		return ob_get_clean();
	}
}
